Skip to main content

connamara/ep3/v1beta1/accounts_api.proto (1)

Download OpenAPI specification:Download

AccountsAPI

GetWhoAmI returns the user information of the caller.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to get the user information of the caller.

object (v1beta1GetWhoAmIRequest)

Request to get the user information of the caller.

Responses

Request samples

Content type
application/json
{ }

Response samples

Content type
application/json
{
  • "user": "string",
  • "user_display_name": "string",
  • "firm": "string",
  • "firm_display_name": "string",
  • "audience": "string",
  • "firm_type": "FIRM_TYPE_UNDEFINED"
}

ListAccounts returns the accounts that the user may use to trade.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to list the accounts belonging to the specified user.

user
string

Fully qualified resource name for the user whos accounts to list (ie: "firms/[firmid]/users/[userid]"). If left empty, lists all accounts.

Responses

Request samples

Content type
application/json
{
  • "user": "string"
}

Response samples

Content type
application/json
{
  • "accounts": [
    ],
  • "display_names": [
    ]
}

ListUsers returns the users that the user may trade on behalf of.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to list the users that the user may trade on behalf of.

object (v1beta1ListUsersRequest)

Request to list the users that the user may trade on behalf of.

Responses

Request samples

Content type
application/json
{ }

Response samples

Content type
application/json
{
  • "users": [
    ],
  • "display_names": [
    ],
  • "firms": [
    ],
  • "firms_display_names": [
    ]
}

MarketDataAPI

GetInstrumentMetadata returns miscellaneous instrument metadata.

Authorizations:
BearerAuth
Request Body schema: application/json
required
object (v1beta1GetInstrumentMetadataRequest)

Responses

Request samples

Content type
application/json
{ }

Response samples

Content type
application/json
{
  • "metadata": {
    }
}

ListInstruments returns a list of instruments matching the request.

Authorizations:
BearerAuth
Request Body schema: application/json
required
page_size
integer <int32>

The maximum number of Instruments to return in a response. This field is optional.

page_token
string

A pagination token returned from a previous call to ListInstruments that indicates where this listing should continue from. This field is optional.

symbols
Array of strings

A list of symbols to filter upon and return in a response. This field is optional.

product_id
string (If set, filter returned instruments belonging to product)
tradable_filter
string (v1beta1TradableFilter)
Default: "TRADABLE_FILTER_UNSET"
Enum: "TRADABLE_FILTER_UNSET" "TRADABLE_FILTER_NON_TRADABLE" "TRADABLE_FILTER_TRADABLE"

TradableFilter.

  • TRADABLE_FILTER_UNSET: Filter is unset.
  • TRADABLE_FILTER_NON_TRADABLE: Filter is set to non-tradable.
  • TRADABLE_FILTER_TRADABLE: Filter is set to tradable.
states
Array of strings (connamaraep3v1beta1InstrumentState)
Items Enum: "INSTRUMENT_STATE_CLOSED" "INSTRUMENT_STATE_OPEN" "INSTRUMENT_STATE_PREOPEN" "INSTRUMENT_STATE_SUSPENDED" "INSTRUMENT_STATE_EXPIRED" "INSTRUMENT_STATE_TERMINATED" "INSTRUMENT_STATE_HALTED" "INSTRUMENT_STATE_MATCH_AND_CLOSE_AUCTION"

The instrument states to filter upon.

type
string (v1beta1InstrumentType)
Default: "INSTRUMENT_TYPE_UNSET"
Enum: "INSTRUMENT_TYPE_UNSET" "INSTRUMENT_TYPE_DEFAULT" "INSTRUMENT_TYPE_FUTURE" "INSTRUMENT_TYPE_OPTION" "INSTRUMENT_TYPE_MULTILEG" "INSTRUMENT_TYPE_IRS" "INSTRUMENT_TYPE_FRA" "INSTRUMENT_TYPE_FSIRS" "INSTRUMENT_TYPE_BASIS" "INSTRUMENT_TYPE_EVENT" "INSTRUMENT_TYPE_OIS" "INSTRUMENT_TYPE_SPS" "INSTRUMENT_TYPE_NDF" "INSTRUMENT_TYPE_FOREX" "INSTRUMENT_TYPE_ZCIS" "INSTRUMENT_TYPE_XCCY"

InstrumentType of the Instrument.

  • INSTRUMENT_TYPE_UNSET: Instrument type is unset.
  • INSTRUMENT_TYPE_DEFAULT: Instrument type is default and does not contain any special type attributes.
  • INSTRUMENT_TYPE_FUTURE: Instrument is a Future.
  • INSTRUMENT_TYPE_OPTION: Instrument is an Option.
  • INSTRUMENT_TYPE_MULTILEG: Instrument is a Multileg.
  • INSTRUMENT_TYPE_IRS: Instrument is an Interest Rate Swap.
  • INSTRUMENT_TYPE_FRA: Instrument is a Forward Rate Agreement Swap.
  • INSTRUMENT_TYPE_FSIRS: Instrument is a Forward Starting Interest Rate Swap.
  • INSTRUMENT_TYPE_BASIS: Instrument is a Basis Swap.
  • INSTRUMENT_TYPE_EVENT: Instrument is an Event Swap.
  • INSTRUMENT_TYPE_OIS: Instrument is an Overnight Index Swap.
  • INSTRUMENT_TYPE_SPS: Instrument is a Single Period Swap.
  • INSTRUMENT_TYPE_NDF: Instrument is a Non-Deliverable Forward.
  • INSTRUMENT_TYPE_FOREX: Instrument is a Foreign Exchange (Forex) Market.
  • INSTRUMENT_TYPE_ZCIS: Instrument is a Zero Coupon Inflation Swap.
  • INSTRUMENT_TYPE_XCCY: Instrument is a Cross Currency Basis Swap.

Responses

Request samples

Content type
application/json
{
  • "page_size": 0,
  • "page_token": "string",
  • "symbols": [
    ],
  • "product_id": "string",
  • "tradable_filter": "TRADABLE_FILTER_UNSET",
  • "states": [
    ],
  • "type": "INSTRUMENT_TYPE_UNSET"
}

Response samples

Content type
application/json
{
  • "instruments": [
    ],
  • "next_page_token": "string",
  • "eof": true
}

ListSymbols returns a list of symbols on the exchange.

Authorizations:
BearerAuth
Request Body schema: application/json
required
object (v1beta1ListSymbolsRequest)

Responses

Request samples

Content type
application/json
{ }

Response samples

Content type
application/json
{
  • "symbols": [
    ]
}

MarketDataSubscriptionAPI

CreateMarketDataSubscription creates a subscription for market data.

Authorizations:
BearerAuth
Request Body schema: application/json
required
symbols
Array of strings
unaggregated
boolean
depth
integer <int32>
snapshot_only
boolean

Responses

Request samples

Content type
application/json
{
  • "symbols": [
    ],
  • "unaggregated": true,
  • "depth": 0,
  • "snapshot_only": true
}

Response samples

Content type
application/x-ndjson
{
  • "result": {
    },
  • "error": {
    }
}

OrderAPI

DownloadExecutions searches for exchange executions using the given details to filter and returns the executions as a csv file stream.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to download executions filtered using the given details as a csv.

start_time
string <date-time>

Start time for the executions to be fetched.

end_time
string <date-time>

End time for the executions to be fetched.

accounts
Array of strings

Fully qualified resource account names to filter upon (ie: "firms/[firmid]/accounts/[accountid]").

Responses

Request samples

Content type
application/json
{
  • "start_time": "2019-08-24T14:15:22Z",
  • "end_time": "2019-08-24T14:15:22Z",
  • "accounts": [
    ]
}

Response samples

Content type
application/x-ndjson
{
  • "result": {
    },
  • "error": {
    }
}

DownloadOrders searches for exchange orders using the given details to filter and returns the orders as a csv file stream.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to download orders filtered using the given details as a csv.

start_time
string <date-time>

Start time for the orders to be fetched.

end_time
string <date-time>

End time for the orders to be fetched.

accounts
Array of strings

Fully qualified resource account names to filter upon (ie: "firms/[firmid]/accounts/[accountid]").

Responses

Request samples

Content type
application/json
{
  • "start_time": "2019-08-24T14:15:22Z",
  • "end_time": "2019-08-24T14:15:22Z",
  • "accounts": [
    ]
}

Response samples

Content type
application/x-ndjson
{
  • "result": {
    },
  • "error": {
    }
}

DownloadTrades searches for exchange trades using the given details to filter and returns the trades as a csv file stream.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to download trades filtered using the given details as a csv.

start_time
string <date-time>

Start time for the trades to be fetched.

end_time
string <date-time>

End time for the trades to be fetched.

accounts
Array of strings

Fully qualified resource account names to filter upon (ie: "firms/[firmid]/accounts/[accountid]").

Responses

Request samples

Content type
application/json
{
  • "start_time": "2019-08-24T14:15:22Z",
  • "end_time": "2019-08-24T14:15:22Z",
  • "accounts": [
    ]
}

Response samples

Content type
application/x-ndjson
{
  • "result": {
    },
  • "error": {
    }
}

GetTradeStats gets aggregated trade data for a given period of time.

Authorizations:
BearerAuth
Request Body schema: application/json
required
symbol
string

Symbol to filter upon.

start_time
string <date-time>

Start time for the trade data time window.

end_time
string <date-time>

End time for the trade data time window.

bars
integer <int32>

Number of individual bars to include for the given time window.

object (v1beta1Date)

Date represents a whole or partial calendar date.

object (v1beta1Date)

Date represents a whole or partial calendar date.

Responses

Request samples

Content type
application/json
{
  • "symbol": "string",
  • "start_time": "2019-08-24T14:15:22Z",
  • "end_time": "2019-08-24T14:15:22Z",
  • "bars": 0,
  • "start_trade_date": {
    },
  • "end_trade_date": {
    }
}

Response samples

Content type
application/json
{
  • "stats": {
    },
  • "bars": [
    ],
  • "bar_start_time": [
    ],
  • "bar_end_time": [
    ]
}

SearchExecutions searches for exchange executions using the given details to filter and returns a list of the found executions.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to search for executions filtered using the given details.

page_size
integer <int32>

The maximum number of fills to return in a response. This field is optional.

page_token
string

A pagination token returned from a previous call to SearchExecutionsRequest. that indicates where this listing should continue from. This field is optional.

order_id
string

Exchange assigned order ID of the order to filter upon.

clord_id
string

Client assigned order ID to filter upon.

start_time
string <date-time>

Start time for the orders to be fetched.

end_time
string <date-time>

End time for the orders to be fetched.

symbol
string

Instrument symbol to filter upon.

types
Array of strings (v1beta1ExecutionType)
Items Enum: "EXECUTION_TYPE_NEW" "EXECUTION_TYPE_PARTIAL_FILL" "EXECUTION_TYPE_FILL" "EXECUTION_TYPE_CANCELED" "EXECUTION_TYPE_REPLACE" "EXECUTION_TYPE_REJECTED" "EXECUTION_TYPE_EXPIRED" "EXECUTION_TYPE_DONE_FOR_DAY"

Execution types to filter upon.

newest_first
boolean

A flag that if set indicates that executions found should be sorted from most recent to oldest.

accounts
Array of strings

Fully qualified resource account names to filter upon (ie: "firms/[firmid]/accounts/[accountid]").

client_account_id
string

Client account ID to filter upon.

client_participant_id
string

Client participant ID to filter upon.

parent_order_id
string

Parent order ID to filter upon.

symbol_sub_type
string

Symbol sub type to filter upon.

exec_ids
Array of strings

Execution IDs to filter upon.

object (v1beta1Date)

Date represents a whole or partial calendar date.

object (v1beta1Date)

Date represents a whole or partial calendar date.

Responses

Request samples

Content type
application/json
{
  • "page_size": 0,
  • "page_token": "string",
  • "order_id": "string",
  • "clord_id": "string",
  • "start_time": "2019-08-24T14:15:22Z",
  • "end_time": "2019-08-24T14:15:22Z",
  • "symbol": "string",
  • "types": [
    ],
  • "newest_first": true,
  • "accounts": [
    ],
  • "client_account_id": "string",
  • "client_participant_id": "string",
  • "parent_order_id": "string",
  • "symbol_sub_type": "string",
  • "exec_ids": [
    ],
  • "start_transact_trade_date": {
    },
  • "end_transact_trade_date": {
    }
}

Response samples

Content type
application/json
{
  • "executions": [
    ],
  • "next_page_token": "string",
  • "eof": true
}

SearchOrders searches for exchange orders using the given details to filter and returns a list of the found orders.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to search for orders filtered using the given details.

page_size
integer <int32>

The maximum number of orders to return in a response. This field is optional.

page_token
string

A pagination token returned from a previous call to SearchOrdersRequest. that indicates where this listing should continue from. This field is optional.

order_id
string

Exchange assigned order ID of the order to filter upon.

clord_id
string

Client assigned order ID to filter upon.

start_time
string <date-time>

Start time for the orders to be fetched.

end_time
string <date-time>

End time for the orders to be fetched.

symbol
string

Instrument symbol to filter upon.

accounts
Array of strings

Fully qualified resource account names to filter upon (ie: "firms/[firmid]/accounts/[accountid]").

side
string (v1beta1Side)
Default: "SIDE_UNDEFINED"
Enum: "SIDE_UNDEFINED" "SIDE_BUY" "SIDE_SELL"

Side indicates the side of an Order.

type
string (v1beta1OrderType)
Default: "ORDER_TYPE_UNDEFINED"
Enum: "ORDER_TYPE_UNDEFINED" "ORDER_TYPE_MARKET_TO_LIMIT" "ORDER_TYPE_LIMIT" "ORDER_TYPE_STOP" "ORDER_TYPE_STOP_LIMIT"

OrderType indicates the type of an order.

  • ORDER_TYPE_MARKET_TO_LIMIT: An order that executes at the current best price. If only partially filled, the remainder is cancelled and reinserted as a LIMIT order with the price equal to the price at which the filled portion of the order executed
  • ORDER_TYPE_LIMIT: An order that will fill only at the specified price or better
  • ORDER_TYPE_STOP: An order that will become active as a MARKET_TO_LIMIT order once a trade has occured at the specified stop price
  • ORDER_TYPE_STOP_LIMIT: An order that will become active as a LIMIT order once a trade has occured at the specified stop price
order_state_filter
string (v1beta1OrderStateFilter)
Default: "ORDER_STATE_FILTER_UNDEFINED"
Enum: "ORDER_STATE_FILTER_UNDEFINED" "ORDER_STATE_FILTER_OPEN" "ORDER_STATE_FILTER_CLOSED" "ORDER_STATE_FILTER_NEW" "ORDER_STATE_FILTER_PARTIALLY_FILLED" "ORDER_STATE_FILTER_FILLED" "ORDER_STATE_FILTER_CANCELED" "ORDER_STATE_FILTER_REPLACED" "ORDER_STATE_FILTER_REJECTED" "ORDER_STATE_FILTER_EXPIRED" "ORDER_STATE_FILTER_PENDING_RISK"

OrderStateFilter describes a filter for searching orders that are open or closed.

cross_id
string

Client assigned Order Cross ID.

host_cross_id
string

Exchange generated Host Cross ID.

client_account_id
string

Client account ID to filter upon.

client_participant_id
string

Client participant ID to filter upon.

parent_order_id
string

Parent order ID to filter upon.

symbol_sub_type
string

Symbol sub type to filter upon.

object (v1beta1Date)

Date represents a whole or partial calendar date.

object (v1beta1Date)

Date represents a whole or partial calendar date.

with_last_execution
boolean

When true indicates that the response should also return the last execution created that is associated with the matched orders.

Responses

Request samples

Content type
application/json
{
  • "page_size": 0,
  • "page_token": "string",
  • "order_id": "string",
  • "clord_id": "string",
  • "start_time": "2019-08-24T14:15:22Z",
  • "end_time": "2019-08-24T14:15:22Z",
  • "symbol": "string",
  • "accounts": [
    ],
  • "side": "SIDE_UNDEFINED",
  • "type": "ORDER_TYPE_UNDEFINED",
  • "order_state_filter": "ORDER_STATE_FILTER_UNDEFINED",
  • "cross_id": "string",
  • "host_cross_id": "string",
  • "client_account_id": "string",
  • "client_participant_id": "string",
  • "parent_order_id": "string",
  • "symbol_sub_type": "string",
  • "start_transact_trade_date": {
    },
  • "end_transact_trade_date": {
    },
  • "with_last_execution": true
}

Response samples

Content type
application/json
{
  • "order": [
    ],
  • "next_page_token": "string",
  • "last_executions": [
    ]
}

SearchTrades searches for exchange trades using the given details to filter and returns a list of the found trades.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to search for trades filtered using the given details.

page_size
integer <int32>

The maximum number of orders to return in a response. This field is optional.

page_token
string

A pagination token returned from a previous call to SearchTradesRequest. that indicates where this listing should continue from. This field is optional.

order_id
string

Exchange assigned order ID of the order to filter upon.

trade_id
string

Exchange assigned trade ID to filter upon.

exec_id
string

Exchange assigned execution ID to filter upon.

start_time
string <date-time>

Start time for the orders to be fetched.

end_time
string <date-time>

End time for the orders to be fetched.

symbol
string

Instrument symbol to filter upon.

accounts
Array of strings

Fully qualified resource account names to filter upon (ie: "firms/[firmid]/accounts/[accountid]").

states
Array of strings (v1beta1TradeState)
Items Enum: "TRADE_STATE_UNDEFINED" "TRADE_STATE_NEW" "TRADE_STATE_CLEARED" "TRADE_STATE_BUSTED" "TRADE_STATE_INFLIGHT" "TRADE_STATE_PENDING_RISK" "TRADE_STATE_PENDING_CLEARED" "TRADE_STATE_REJECTED" "TRADE_STATE_CLEARING_ACKNOWLEDGED" "TRADE_STATE_RETRY_REQUEST"

Trade states to filter upon.

trade_link_id
string (Trade Link ID to filter upon)

Responses

Request samples

Content type
application/json
{
  • "page_size": 0,
  • "page_token": "string",
  • "order_id": "string",
  • "trade_id": "string",
  • "exec_id": "string",
  • "start_time": "2019-08-24T14:15:22Z",
  • "end_time": "2019-08-24T14:15:22Z",
  • "symbol": "string",
  • "accounts": [
    ],
  • "states": [
    ],
  • "trade_link_id": "string"
}

Response samples

Content type
application/json
{
  • "trade": [
    ],
  • "next_page_token": "string"
}

OrderEntryAPI

CancelOrder requests cancellation of a working order.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to cancel an existing order with the given details.

order_id
string

Exchange assigned ID for the order to be cancelled (required).

clord_id
string

Client assigned ID for the order cancel.

symbol
string

The instrument symbol for the order (required).

symbol_sub_type
string

The sub type of the instrument symbol.

Responses

Request samples

Content type
application/json
{
  • "order_id": "string",
  • "clord_id": "string",
  • "symbol": "string",
  • "symbol_sub_type": "string"
}

Response samples

Content type
application/json
{ }

CancelOrderList requests cancellation of a list of working orders.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to cancel multiple existing orders with the given details.

Array of objects (v1beta1CancelOrderRequest)

A list of requests to cancel orders.

Array
order_id
string

Exchange assigned ID for the order to be cancelled (required).

clord_id
string

Client assigned ID for the order cancel.

symbol
string

The instrument symbol for the order (required).

symbol_sub_type
string

The sub type of the instrument symbol.

Responses

Request samples

Content type
application/json
{
  • "requests": [
    ]
}

Response samples

Content type
application/json
{
  • "responses": [
    ]
}

CancelReplaceOrder requests modification of a working order.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to update an existing order with the given details.

order_id
string

Exchange assigned ID for the order to be replaced (required).

clord_id
string

Client assigned ID for the cancel replace order.

symbol
string

Desired instrument's symbol (required).

price
string <int64>

Desired limit price for the replaced order (required for limit and stop limit orders).

order_qty
string <int64>

Desired order quantity for the replaced order.

time_in_force
string (v1beta1TimeInForce)
Default: "TIME_IN_FORCE_UNDEFINED"
Enum: "TIME_IN_FORCE_UNDEFINED" "TIME_IN_FORCE_DAY" "TIME_IN_FORCE_GOOD_TILL_CANCEL" "TIME_IN_FORCE_IMMEDIATE_OR_CANCEL" "TIME_IN_FORCE_GOOD_TILL_TIME" "TIME_IN_FORCE_FILL_OR_KILL"

TimeInForce specifies how long the order remains in effect.

  • TIME_IN_FORCE_UNDEFINED: An unset value for TimeInForce. In the context of inserting orders, this will be interpreted as TIME_IN_FORCE_DAY
  • TIME_IN_FORCE_DAY: Order will automatically cancel if it has not been filled by the close of the trading day
  • TIME_IN_FORCE_GOOD_TILL_CANCEL: Order will remain active until filled or cancelled
  • TIME_IN_FORCE_IMMEDIATE_OR_CANCEL: Order will attempt to fill immediately, then cancel any unfilled portions of the order
  • TIME_IN_FORCE_GOOD_TILL_TIME: Order will remain active until filled or until the time specified
  • TIME_IN_FORCE_FILL_OR_KILL: Order will attempt to fill immediately for the entire order quantity, then cancel if the order was unable to be filled.
stop_price
string <int64>

Desired stop price for the replaced order (required for stop and stop limit orders).

min_qty
string <int64>

Desired minimum quantity for the replaced order (optional for IOC time in force).

all_or_none
boolean

A flag that if set indicates that either all of the order quantity should be filled, or none of it (partial fills will not be allowed).

participate_dont_initiate
boolean

A flag that if set indicates that immediate match is not desired.

symbol_sub_type
string

The sub type of the instrument symbol.

strict_limit
boolean

A flag that if set indicates this particular order must be filled at the exact limit price specified without price improvement.

good_till_time
string <date-time>

The time at which this order shall expire if the time in force is set as good till time.

best_limit
boolean

A flag that if set indicates that the price of a limit order shall be set to the price at the top of the book on the same side as this order.

immediately_executable_limit
boolean

A flag that if set indicates that the price of a limit order shall be set to the price at the top of the book on the opposing side as this order, thus able to immediately match.

manual_order_indicator
string (v1beta1ManualOrderIndicator)
Default: "MANUAL_ORDER_INDICATOR_UNDEFINED"
Enum: "MANUAL_ORDER_INDICATOR_UNDEFINED" "MANUAL_ORDER_INDICATOR_MANUAL" "MANUAL_ORDER_INDICATOR_AUTOMATED"

ManualOrderIndicator designates the manual or automated nature of an order.

  • MANUAL_ORDER_INDICATOR_UNDEFINED: An unset value for the manual order indicator.
  • MANUAL_ORDER_INDICATOR_MANUAL: The order was initially received via manual entry.
  • MANUAL_ORDER_INDICATOR_AUTOMATED: The order was initially received electronically.
clord_link_id
string (Client assigned group ID for the order)

Responses

Request samples

Content type
application/json
{
  • "order_id": "string",
  • "clord_id": "string",
  • "symbol": "string",
  • "price": "string",
  • "order_qty": "string",
  • "time_in_force": "TIME_IN_FORCE_UNDEFINED",
  • "stop_price": "string",
  • "min_qty": "string",
  • "all_or_none": true,
  • "participate_dont_initiate": true,
  • "symbol_sub_type": "string",
  • "strict_limit": true,
  • "good_till_time": "2019-08-24T14:15:22Z",
  • "best_limit": true,
  • "immediately_executable_limit": true,
  • "manual_order_indicator": "MANUAL_ORDER_INDICATOR_UNDEFINED",
  • "clord_link_id": "string"
}

Response samples

Content type
application/json
{ }

CancelReplaceOrderList requests modification of a list of working orders.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to update multiple existing orders with the given details.

Array of objects (connamaraep3v1beta1CancelReplaceOrderRequest)

A list of requests to update orders.

Array
order_id
string

Exchange assigned ID for the order to be replaced (required).

clord_id
string

Client assigned ID for the cancel replace order.

symbol
string

Desired instrument's symbol (required).

price
string <int64>

Desired limit price for the replaced order (required for limit and stop limit orders).

order_qty
string <int64>

Desired order quantity for the replaced order.

time_in_force
string (v1beta1TimeInForce)
Default: "TIME_IN_FORCE_UNDEFINED"
Enum: "TIME_IN_FORCE_UNDEFINED" "TIME_IN_FORCE_DAY" "TIME_IN_FORCE_GOOD_TILL_CANCEL" "TIME_IN_FORCE_IMMEDIATE_OR_CANCEL" "TIME_IN_FORCE_GOOD_TILL_TIME" "TIME_IN_FORCE_FILL_OR_KILL"

TimeInForce specifies how long the order remains in effect.

  • TIME_IN_FORCE_UNDEFINED: An unset value for TimeInForce. In the context of inserting orders, this will be interpreted as TIME_IN_FORCE_DAY
  • TIME_IN_FORCE_DAY: Order will automatically cancel if it has not been filled by the close of the trading day
  • TIME_IN_FORCE_GOOD_TILL_CANCEL: Order will remain active until filled or cancelled
  • TIME_IN_FORCE_IMMEDIATE_OR_CANCEL: Order will attempt to fill immediately, then cancel any unfilled portions of the order
  • TIME_IN_FORCE_GOOD_TILL_TIME: Order will remain active until filled or until the time specified
  • TIME_IN_FORCE_FILL_OR_KILL: Order will attempt to fill immediately for the entire order quantity, then cancel if the order was unable to be filled.
stop_price
string <int64>

Desired stop price for the replaced order (required for stop and stop limit orders).

min_qty
string <int64>

Desired minimum quantity for the replaced order (optional for IOC time in force).

all_or_none
boolean

A flag that if set indicates that either all of the order quantity should be filled, or none of it (partial fills will not be allowed).

participate_dont_initiate
boolean

A flag that if set indicates that immediate match is not desired.

symbol_sub_type
string

The sub type of the instrument symbol.

strict_limit
boolean

A flag that if set indicates this particular order must be filled at the exact limit price specified without price improvement.

good_till_time
string <date-time>

The time at which this order shall expire if the time in force is set as good till time.

best_limit
boolean

A flag that if set indicates that the price of a limit order shall be set to the price at the top of the book on the same side as this order.

immediately_executable_limit
boolean

A flag that if set indicates that the price of a limit order shall be set to the price at the top of the book on the opposing side as this order, thus able to immediately match.

manual_order_indicator
string (v1beta1ManualOrderIndicator)
Default: "MANUAL_ORDER_INDICATOR_UNDEFINED"
Enum: "MANUAL_ORDER_INDICATOR_UNDEFINED" "MANUAL_ORDER_INDICATOR_MANUAL" "MANUAL_ORDER_INDICATOR_AUTOMATED"

ManualOrderIndicator designates the manual or automated nature of an order.

  • MANUAL_ORDER_INDICATOR_UNDEFINED: An unset value for the manual order indicator.
  • MANUAL_ORDER_INDICATOR_MANUAL: The order was initially received via manual entry.
  • MANUAL_ORDER_INDICATOR_AUTOMATED: The order was initially received electronically.
clord_link_id
string (Client assigned group ID for the order)

Responses

Request samples

Content type
application/json
{
  • "requests": [
    ]
}

Response samples

Content type
application/json
{
  • "responses": [
    ]
}

CreateOrderSubscription creates a subscription for working orders and updates.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to start an order subscription to get snapshots and updates for this session.

symbols
Array of strings

A list of symbols to filter upon and return in streamed responses. This field is optional.

accounts
Array of strings

A list of accounts to filter upon and return in streamed responses. This field is optional.

snapshot_only
boolean

If true, only return the current set of snapshots for working orders and do not keep an open subscription.

Responses

Request samples

Content type
application/json
{
  • "symbols": [
    ],
  • "accounts": [
    ],
  • "snapshot_only": true
}

Response samples

Content type
application/x-ndjson
{
  • "result": {
    },
  • "error": {
    }
}

GetOpenOrders returns a snapshot of working orders.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to get open orders.

symbols
Array of strings

A list of symbols to filter upon and return in the response. This field is optional.

accounts
Array of strings

A list of accounts to filter upon and return in the response. This field is optional.

Responses

Request samples

Content type
application/json
{
  • "symbols": [
    ],
  • "accounts": [
    ]
}

Response samples

Content type
application/json
{
  • "orders": [
    ]
}

InsertOrder inserts orders into the exchange and returns the exchange assigned order ID.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to insert an order with the given details.

type
string (v1beta1OrderType)
Default: "ORDER_TYPE_UNDEFINED"
Enum: "ORDER_TYPE_UNDEFINED" "ORDER_TYPE_MARKET_TO_LIMIT" "ORDER_TYPE_LIMIT" "ORDER_TYPE_STOP" "ORDER_TYPE_STOP_LIMIT"

OrderType indicates the type of an order.

  • ORDER_TYPE_MARKET_TO_LIMIT: An order that executes at the current best price. If only partially filled, the remainder is cancelled and reinserted as a LIMIT order with the price equal to the price at which the filled portion of the order executed
  • ORDER_TYPE_LIMIT: An order that will fill only at the specified price or better
  • ORDER_TYPE_STOP: An order that will become active as a MARKET_TO_LIMIT order once a trade has occured at the specified stop price
  • ORDER_TYPE_STOP_LIMIT: An order that will become active as a LIMIT order once a trade has occured at the specified stop price
side
string (v1beta1Side)
Default: "SIDE_UNDEFINED"
Enum: "SIDE_UNDEFINED" "SIDE_BUY" "SIDE_SELL"

Side indicates the side of an Order.

order_qty
string <int64>

The quantity to be ordered (One of order_qty and cash_order_qty must be set. If set, must be > 0).

symbol
string

The symbol of the instrument to be ordered (required for all orders).

price
string <int64>

Integer representation of limit price (required for limit and stop limit orders).

time_in_force
string (v1beta1TimeInForce)
Default: "TIME_IN_FORCE_UNDEFINED"
Enum: "TIME_IN_FORCE_UNDEFINED" "TIME_IN_FORCE_DAY" "TIME_IN_FORCE_GOOD_TILL_CANCEL" "TIME_IN_FORCE_IMMEDIATE_OR_CANCEL" "TIME_IN_FORCE_GOOD_TILL_TIME" "TIME_IN_FORCE_FILL_OR_KILL"

TimeInForce specifies how long the order remains in effect.

  • TIME_IN_FORCE_UNDEFINED: An unset value for TimeInForce. In the context of inserting orders, this will be interpreted as TIME_IN_FORCE_DAY
  • TIME_IN_FORCE_DAY: Order will automatically cancel if it has not been filled by the close of the trading day
  • TIME_IN_FORCE_GOOD_TILL_CANCEL: Order will remain active until filled or cancelled
  • TIME_IN_FORCE_IMMEDIATE_OR_CANCEL: Order will attempt to fill immediately, then cancel any unfilled portions of the order
  • TIME_IN_FORCE_GOOD_TILL_TIME: Order will remain active until filled or until the time specified
  • TIME_IN_FORCE_FILL_OR_KILL: Order will attempt to fill immediately for the entire order quantity, then cancel if the order was unable to be filled.
clord_id
string

Client assigned ID for the order.

account
string

The trading account for this order.

stop_price
string <int64>

Integer representation of stop price (required for stop and stop limit orders).

min_qty
string <int64>

Minimum order quantity to fill at once. Matches for fills under this amount will not be made (optional for IOC time in force).

self_match_prevention_id
string

Client assigned Self Match Prevention ID (required to use the optional Self Match Prevention functionality).

quote
string

If set, the quote to accept.

all_or_none
boolean

A flag that if set indicates that either all of the order quantity should be filled, or none of it (partial fills will not be allowed).

session_id
string

Client assigned Session ID (required to use the optional Cancel on Disconnect functionality).

user
string

The participant for which an agent is submitting the order (an agent must set this field, ignored otherwise).

client_account_id
string

Client assigned free-form account ID for the order.

client_participant_id
string

Client assigned free-form participant ID for the order.

participate_dont_initiate
boolean

A flag that if set indicates that immediate match is not desired.

cash_order_qty
string <int64>

Fixed point decimal representation of the total cash order qty. (One of order_qty and cash_order_qty must be set. If set, must be > 0 and order_type must be MARKET_TO_LIMIT).

symbol_sub_type
string

The sub type of the instrument symbol.

strict_limit
boolean

A flag that if set indicates this particular order must be filled at the exact limit price specified without price improvement.

good_till_time
string <date-time>

The time at which this order shall expire (required for time_in_force of GOOD_TILL_TIME, ignored otherwise).

best_limit
boolean

A flag that if set indicates that the price of a limit order shall be set to the price at the top of the book on the same side as this order.

immediately_executable_limit
boolean

A flag that if set indicates that the price of a limit order shall be set to the price at the top of the book on the opposing side as this order, thus able to immediately match.

trigger_method
string (v1beta1ConditionTriggerMethod)
Default: "CONDITION_TRIGGER_METHOD_UNDEFINED"
Enum: "CONDITION_TRIGGER_METHOD_UNDEFINED" "CONDITION_TRIGGER_METHOD_LAST_PRICE" "CONDITION_TRIGGER_METHOD_SETTLEMENT_PRICE"

ConditionTriggerMethod is the methodology used to trigger an order for insertion onto the book.

  • CONDITION_TRIGGER_METHOD_UNDEFINED: An unset value for the trigger method must be used when the order type is not meant to trigger (a limit order for instance) or uses the default last price method for orders that do trigger (a stop order for instance).
  • CONDITION_TRIGGER_METHOD_LAST_PRICE: Trigger the order using the last trade price on the book.
  • CONDITION_TRIGGER_METHOD_SETTLEMENT_PRICE: Trigger the order using the settlement price on the book.
self_match_prevention_instruction
string (v1beta1SelfMatchPreventionInstruction)
Default: "SELF_MATCH_PREVENTION_INSTRUCTION_UNDEFINED"
Enum: "SELF_MATCH_PREVENTION_INSTRUCTION_UNDEFINED" "SELF_MATCH_PREVENTION_INSTRUCTION_REJECT_AGGRESSOR" "SELF_MATCH_PREVENTION_INSTRUCTION_CANCEL_RESTING" "SELF_MATCH_PREVENTION_INSTRUCTION_REMOVE_BOTH"

SelfMatchPreventionInstruction is the methodology used to handle self match prevention upon insertion onto the book.

  • SELF_MATCH_PREVENTION_INSTRUCTION_UNDEFINED: An unset value for the self match prevention instruction uses the default behavior of the exchange, which is to reject the incoming order and allow resting orders to remain on the book.
  • SELF_MATCH_PREVENTION_INSTRUCTION_REJECT_AGGRESSOR: Reject the incoming aggressor order and allow resting orders to remain on the book.
  • SELF_MATCH_PREVENTION_INSTRUCTION_CANCEL_RESTING: Cancel any resting orders on the book that would self match and allow the aggressor to insert on the book.
  • SELF_MATCH_PREVENTION_INSTRUCTION_REMOVE_BOTH: Cancel any resting orders on the book that would self match and reject the aggressor insertion on the book.
order_capacity
string (v1beta1OrderCapacity)
Default: "ORDER_CAPACITY_UNDEFINED"
Enum: "ORDER_CAPACITY_UNDEFINED" "ORDER_CAPACITY_AGENCY" "ORDER_CAPACITY_PRINCIPAL" "ORDER_CAPACITY_PROPRIETARY" "ORDER_CAPACITY_INDIVIDUAL" "ORDER_CAPACITY_RISKLESS_PRINCIPAL" "ORDER_CAPACITY_AGENT_FOR_OTHER_MEMBER"

OrderCapacity designates the capacity of the party placing an order.

  • ORDER_CAPACITY_UNDEFINED: An unset value for the order capacity.
  • ORDER_CAPACITY_AGENCY: Firm is acting to match a customer order with another participant in the market in an agency capacity.
  • ORDER_CAPACITY_PRINCIPAL: Firm is trading with its own inventory and capital in a principal capacity.
  • ORDER_CAPACITY_PROPRIETARY: Firm is trading with its own inventory and capital in a proprietary capacity.
  • ORDER_CAPACITY_INDIVIDUAL: An individual is trading with their own inventory and capital.
  • ORDER_CAPACITY_RISKLESS_PRINCIPAL: Firm is placing a principal order that is party to an offsetting transaction.
  • ORDER_CAPACITY_AGENT_FOR_OTHER_MEMBER: Firm is acting to match a customer order with another participant in the market on behalf of another member.
ignore_price_validity_checks
boolean

A flag that if set indicates that this order is exempt from instrument level price, order, and total notional limits. Only allowed in case of market sell orders to support liquidation.

manual_order_indicator
string (v1beta1ManualOrderIndicator)
Default: "MANUAL_ORDER_INDICATOR_UNDEFINED"
Enum: "MANUAL_ORDER_INDICATOR_UNDEFINED" "MANUAL_ORDER_INDICATOR_MANUAL" "MANUAL_ORDER_INDICATOR_AUTOMATED"

ManualOrderIndicator designates the manual or automated nature of an order.

  • MANUAL_ORDER_INDICATOR_UNDEFINED: An unset value for the manual order indicator.
  • MANUAL_ORDER_INDICATOR_MANUAL: The order was initially received via manual entry.
  • MANUAL_ORDER_INDICATOR_AUTOMATED: The order was initially received electronically.
commission_override_basis_points
string

If present and an eligible singular commission with allow_order_entry_override is present for the order, assigns basis points to this value.

commission_override_flat_fee
string

If present and an eligible singular commission with allow_order_entry_override is present for the order, assigns flat fee to this value.

clord_link_id
string (Client assigned group ID for the order)
visible_qty
string <int64>

The visible quantity of the order. A non-zero value in this field indicates that the order is an iceberg order.

Responses

Request samples

Content type
application/json
{
  • "type": "ORDER_TYPE_UNDEFINED",
  • "side": "SIDE_UNDEFINED",
  • "order_qty": "string",
  • "symbol": "string",
  • "price": "string",
  • "time_in_force": "TIME_IN_FORCE_UNDEFINED",
  • "clord_id": "string",
  • "account": "string",
  • "stop_price": "string",
  • "min_qty": "string",
  • "self_match_prevention_id": "string",
  • "quote": "string",
  • "all_or_none": true,
  • "session_id": "string",
  • "user": "string",
  • "client_account_id": "string",
  • "client_participant_id": "string",
  • "participate_dont_initiate": true,
  • "cash_order_qty": "string",
  • "symbol_sub_type": "string",
  • "strict_limit": true,
  • "good_till_time": "2019-08-24T14:15:22Z",
  • "best_limit": true,
  • "immediately_executable_limit": true,
  • "trigger_method": "CONDITION_TRIGGER_METHOD_UNDEFINED",
  • "self_match_prevention_instruction": "SELF_MATCH_PREVENTION_INSTRUCTION_UNDEFINED",
  • "order_capacity": "ORDER_CAPACITY_UNDEFINED",
  • "ignore_price_validity_checks": true,
  • "manual_order_indicator": "MANUAL_ORDER_INDICATOR_UNDEFINED",
  • "commission_override_basis_points": "string",
  • "commission_override_flat_fee": "string",
  • "clord_link_id": "string",
  • "visible_qty": "string"
}

Response samples

Content type
application/json
{
  • "order_id": "string"
}

InsertOrderCross creates a new order cross and returns the exchange assigned order IDs.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to insert orders for a cross with the given details.

Array of objects (connamaraep3v1beta1InsertOrderRequest)

A list of orders to insert (Only supports 2 orders at a time).

cross_type
string (v1beta1CrossType)
Default: "CROSS_TYPE_UNDEFINED"
Enum: "CROSS_TYPE_UNDEFINED" "CROSS_TYPE_ALL_OR_NONE"

CrossType specifies the type of order cross. Must be set when inserting a cross.

  • CROSS_TYPE_ALL_OR_NONE: Cross order will either fill all of the order quantity or none of it
cross_id
string

Client assigned free-form ID for the cross (required).

cross_prioritized_side
string (v1beta1Side)
Default: "SIDE_UNDEFINED"
Enum: "SIDE_UNDEFINED" "SIDE_BUY" "SIDE_SELL"

Side indicates the side of an Order.

block_trade_indicator
boolean

A flag that if set indicates that this cross represents a block trade.

transaction_booked_time
string <date-time>

The time at which the order was booked.

Responses

Request samples

Content type
application/json
{
  • "requests": [
    ],
  • "cross_type": "CROSS_TYPE_UNDEFINED",
  • "cross_id": "string",
  • "cross_prioritized_side": "SIDE_UNDEFINED",
  • "block_trade_indicator": true,
  • "transaction_booked_time": "2019-08-24T14:15:22Z"
}

Response samples

Content type
application/json
{
  • "responses": [
    ]
}

InsertOrderList inserts a list of orders into the exchange and returns the exchange assigned order IDs.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to insert multiple orders with the given details.

Array of objects (connamaraep3v1beta1InsertOrderRequest)

A list of orders to insert.

Array
type
string (v1beta1OrderType)
Default: "ORDER_TYPE_UNDEFINED"
Enum: "ORDER_TYPE_UNDEFINED" "ORDER_TYPE_MARKET_TO_LIMIT" "ORDER_TYPE_LIMIT" "ORDER_TYPE_STOP" "ORDER_TYPE_STOP_LIMIT"

OrderType indicates the type of an order.

  • ORDER_TYPE_MARKET_TO_LIMIT: An order that executes at the current best price. If only partially filled, the remainder is cancelled and reinserted as a LIMIT order with the price equal to the price at which the filled portion of the order executed
  • ORDER_TYPE_LIMIT: An order that will fill only at the specified price or better
  • ORDER_TYPE_STOP: An order that will become active as a MARKET_TO_LIMIT order once a trade has occured at the specified stop price
  • ORDER_TYPE_STOP_LIMIT: An order that will become active as a LIMIT order once a trade has occured at the specified stop price
side
string (v1beta1Side)
Default: "SIDE_UNDEFINED"
Enum: "SIDE_UNDEFINED" "SIDE_BUY" "SIDE_SELL"

Side indicates the side of an Order.

order_qty
string <int64>

The quantity to be ordered (One of order_qty and cash_order_qty must be set. If set, must be > 0).

symbol
string

The symbol of the instrument to be ordered (required for all orders).

price
string <int64>

Integer representation of limit price (required for limit and stop limit orders).

time_in_force
string (v1beta1TimeInForce)
Default: "TIME_IN_FORCE_UNDEFINED"
Enum: "TIME_IN_FORCE_UNDEFINED" "TIME_IN_FORCE_DAY" "TIME_IN_FORCE_GOOD_TILL_CANCEL" "TIME_IN_FORCE_IMMEDIATE_OR_CANCEL" "TIME_IN_FORCE_GOOD_TILL_TIME" "TIME_IN_FORCE_FILL_OR_KILL"

TimeInForce specifies how long the order remains in effect.

  • TIME_IN_FORCE_UNDEFINED: An unset value for TimeInForce. In the context of inserting orders, this will be interpreted as TIME_IN_FORCE_DAY
  • TIME_IN_FORCE_DAY: Order will automatically cancel if it has not been filled by the close of the trading day
  • TIME_IN_FORCE_GOOD_TILL_CANCEL: Order will remain active until filled or cancelled
  • TIME_IN_FORCE_IMMEDIATE_OR_CANCEL: Order will attempt to fill immediately, then cancel any unfilled portions of the order
  • TIME_IN_FORCE_GOOD_TILL_TIME: Order will remain active until filled or until the time specified
  • TIME_IN_FORCE_FILL_OR_KILL: Order will attempt to fill immediately for the entire order quantity, then cancel if the order was unable to be filled.
clord_id
string

Client assigned ID for the order.

account
string

The trading account for this order.

stop_price
string <int64>

Integer representation of stop price (required for stop and stop limit orders).

min_qty
string <int64>

Minimum order quantity to fill at once. Matches for fills under this amount will not be made (optional for IOC time in force).

self_match_prevention_id
string

Client assigned Self Match Prevention ID (required to use the optional Self Match Prevention functionality).

quote
string

If set, the quote to accept.

all_or_none
boolean

A flag that if set indicates that either all of the order quantity should be filled, or none of it (partial fills will not be allowed).

session_id
string

Client assigned Session ID (required to use the optional Cancel on Disconnect functionality).

user
string

The participant for which an agent is submitting the order (an agent must set this field, ignored otherwise).

client_account_id
string

Client assigned free-form account ID for the order.

client_participant_id
string

Client assigned free-form participant ID for the order.

participate_dont_initiate
boolean

A flag that if set indicates that immediate match is not desired.

cash_order_qty
string <int64>

Fixed point decimal representation of the total cash order qty. (One of order_qty and cash_order_qty must be set. If set, must be > 0 and order_type must be MARKET_TO_LIMIT).

symbol_sub_type
string

The sub type of the instrument symbol.

strict_limit
boolean

A flag that if set indicates this particular order must be filled at the exact limit price specified without price improvement.

good_till_time
string <date-time>

The time at which this order shall expire (required for time_in_force of GOOD_TILL_TIME, ignored otherwise).

best_limit
boolean

A flag that if set indicates that the price of a limit order shall be set to the price at the top of the book on the same side as this order.

immediately_executable_limit
boolean

A flag that if set indicates that the price of a limit order shall be set to the price at the top of the book on the opposing side as this order, thus able to immediately match.

trigger_method
string (v1beta1ConditionTriggerMethod)
Default: "CONDITION_TRIGGER_METHOD_UNDEFINED"
Enum: "CONDITION_TRIGGER_METHOD_UNDEFINED" "CONDITION_TRIGGER_METHOD_LAST_PRICE" "CONDITION_TRIGGER_METHOD_SETTLEMENT_PRICE"

ConditionTriggerMethod is the methodology used to trigger an order for insertion onto the book.

  • CONDITION_TRIGGER_METHOD_UNDEFINED: An unset value for the trigger method must be used when the order type is not meant to trigger (a limit order for instance) or uses the default last price method for orders that do trigger (a stop order for instance).
  • CONDITION_TRIGGER_METHOD_LAST_PRICE: Trigger the order using the last trade price on the book.
  • CONDITION_TRIGGER_METHOD_SETTLEMENT_PRICE: Trigger the order using the settlement price on the book.
self_match_prevention_instruction
string (v1beta1SelfMatchPreventionInstruction)
Default: "SELF_MATCH_PREVENTION_INSTRUCTION_UNDEFINED"
Enum: "SELF_MATCH_PREVENTION_INSTRUCTION_UNDEFINED" "SELF_MATCH_PREVENTION_INSTRUCTION_REJECT_AGGRESSOR" "SELF_MATCH_PREVENTION_INSTRUCTION_CANCEL_RESTING" "SELF_MATCH_PREVENTION_INSTRUCTION_REMOVE_BOTH"

SelfMatchPreventionInstruction is the methodology used to handle self match prevention upon insertion onto the book.

  • SELF_MATCH_PREVENTION_INSTRUCTION_UNDEFINED: An unset value for the self match prevention instruction uses the default behavior of the exchange, which is to reject the incoming order and allow resting orders to remain on the book.
  • SELF_MATCH_PREVENTION_INSTRUCTION_REJECT_AGGRESSOR: Reject the incoming aggressor order and allow resting orders to remain on the book.
  • SELF_MATCH_PREVENTION_INSTRUCTION_CANCEL_RESTING: Cancel any resting orders on the book that would self match and allow the aggressor to insert on the book.
  • SELF_MATCH_PREVENTION_INSTRUCTION_REMOVE_BOTH: Cancel any resting orders on the book that would self match and reject the aggressor insertion on the book.
order_capacity
string (v1beta1OrderCapacity)
Default: "ORDER_CAPACITY_UNDEFINED"
Enum: "ORDER_CAPACITY_UNDEFINED" "ORDER_CAPACITY_AGENCY" "ORDER_CAPACITY_PRINCIPAL" "ORDER_CAPACITY_PROPRIETARY" "ORDER_CAPACITY_INDIVIDUAL" "ORDER_CAPACITY_RISKLESS_PRINCIPAL" "ORDER_CAPACITY_AGENT_FOR_OTHER_MEMBER"

OrderCapacity designates the capacity of the party placing an order.

  • ORDER_CAPACITY_UNDEFINED: An unset value for the order capacity.
  • ORDER_CAPACITY_AGENCY: Firm is acting to match a customer order with another participant in the market in an agency capacity.
  • ORDER_CAPACITY_PRINCIPAL: Firm is trading with its own inventory and capital in a principal capacity.
  • ORDER_CAPACITY_PROPRIETARY: Firm is trading with its own inventory and capital in a proprietary capacity.
  • ORDER_CAPACITY_INDIVIDUAL: An individual is trading with their own inventory and capital.
  • ORDER_CAPACITY_RISKLESS_PRINCIPAL: Firm is placing a principal order that is party to an offsetting transaction.
  • ORDER_CAPACITY_AGENT_FOR_OTHER_MEMBER: Firm is acting to match a customer order with another participant in the market on behalf of another member.
ignore_price_validity_checks
boolean

A flag that if set indicates that this order is exempt from instrument level price, order, and total notional limits. Only allowed in case of market sell orders to support liquidation.

manual_order_indicator
string (v1beta1ManualOrderIndicator)
Default: "MANUAL_ORDER_INDICATOR_UNDEFINED"
Enum: "MANUAL_ORDER_INDICATOR_UNDEFINED" "MANUAL_ORDER_INDICATOR_MANUAL" "MANUAL_ORDER_INDICATOR_AUTOMATED"

ManualOrderIndicator designates the manual or automated nature of an order.

  • MANUAL_ORDER_INDICATOR_UNDEFINED: An unset value for the manual order indicator.
  • MANUAL_ORDER_INDICATOR_MANUAL: The order was initially received via manual entry.
  • MANUAL_ORDER_INDICATOR_AUTOMATED: The order was initially received electronically.
commission_override_basis_points
string

If present and an eligible singular commission with allow_order_entry_override is present for the order, assigns basis points to this value.

commission_override_flat_fee
string

If present and an eligible singular commission with allow_order_entry_override is present for the order, assigns flat fee to this value.

clord_link_id
string (Client assigned group ID for the order)
visible_qty
string <int64>

The visible quantity of the order. A non-zero value in this field indicates that the order is an iceberg order.

Responses

Request samples

Content type
application/json
{
  • "requests": [
    ]
}

Response samples

Content type
application/json
{
  • "responses": [
    ]
}

PreviewOrder creates an order and assigns attributes but does not insert the order into the exchange.

Authorizations:
BearerAuth
Request Body schema: application/json
required
object (connamaraep3v1beta1InsertOrderRequest)

Request to insert an order with the given details.

type
string (v1beta1OrderType)
Default: "ORDER_TYPE_UNDEFINED"
Enum: "ORDER_TYPE_UNDEFINED" "ORDER_TYPE_MARKET_TO_LIMIT" "ORDER_TYPE_LIMIT" "ORDER_TYPE_STOP" "ORDER_TYPE_STOP_LIMIT"

OrderType indicates the type of an order.

  • ORDER_TYPE_MARKET_TO_LIMIT: An order that executes at the current best price. If only partially filled, the remainder is cancelled and reinserted as a LIMIT order with the price equal to the price at which the filled portion of the order executed
  • ORDER_TYPE_LIMIT: An order that will fill only at the specified price or better
  • ORDER_TYPE_STOP: An order that will become active as a MARKET_TO_LIMIT order once a trade has occured at the specified stop price
  • ORDER_TYPE_STOP_LIMIT: An order that will become active as a LIMIT order once a trade has occured at the specified stop price
side
string (v1beta1Side)
Default: "SIDE_UNDEFINED"
Enum: "SIDE_UNDEFINED" "SIDE_BUY" "SIDE_SELL"

Side indicates the side of an Order.

order_qty
string <int64>

The quantity to be ordered (One of order_qty and cash_order_qty must be set. If set, must be > 0).

symbol
string

The symbol of the instrument to be ordered (required for all orders).

price
string <int64>

Integer representation of limit price (required for limit and stop limit orders).

time_in_force
string (v1beta1TimeInForce)
Default: "TIME_IN_FORCE_UNDEFINED"
Enum: "TIME_IN_FORCE_UNDEFINED" "TIME_IN_FORCE_DAY" "TIME_IN_FORCE_GOOD_TILL_CANCEL" "TIME_IN_FORCE_IMMEDIATE_OR_CANCEL" "TIME_IN_FORCE_GOOD_TILL_TIME" "TIME_IN_FORCE_FILL_OR_KILL"

TimeInForce specifies how long the order remains in effect.

  • TIME_IN_FORCE_UNDEFINED: An unset value for TimeInForce. In the context of inserting orders, this will be interpreted as TIME_IN_FORCE_DAY
  • TIME_IN_FORCE_DAY: Order will automatically cancel if it has not been filled by the close of the trading day
  • TIME_IN_FORCE_GOOD_TILL_CANCEL: Order will remain active until filled or cancelled
  • TIME_IN_FORCE_IMMEDIATE_OR_CANCEL: Order will attempt to fill immediately, then cancel any unfilled portions of the order
  • TIME_IN_FORCE_GOOD_TILL_TIME: Order will remain active until filled or until the time specified
  • TIME_IN_FORCE_FILL_OR_KILL: Order will attempt to fill immediately for the entire order quantity, then cancel if the order was unable to be filled.
clord_id
string

Client assigned ID for the order.

account
string

The trading account for this order.

stop_price
string <int64>

Integer representation of stop price (required for stop and stop limit orders).

min_qty
string <int64>

Minimum order quantity to fill at once. Matches for fills under this amount will not be made (optional for IOC time in force).

self_match_prevention_id
string

Client assigned Self Match Prevention ID (required to use the optional Self Match Prevention functionality).

quote
string

If set, the quote to accept.

all_or_none
boolean

A flag that if set indicates that either all of the order quantity should be filled, or none of it (partial fills will not be allowed).

session_id
string

Client assigned Session ID (required to use the optional Cancel on Disconnect functionality).

user
string

The participant for which an agent is submitting the order (an agent must set this field, ignored otherwise).

client_account_id
string

Client assigned free-form account ID for the order.

client_participant_id
string

Client assigned free-form participant ID for the order.

participate_dont_initiate
boolean

A flag that if set indicates that immediate match is not desired.

cash_order_qty
string <int64>

Fixed point decimal representation of the total cash order qty. (One of order_qty and cash_order_qty must be set. If set, must be > 0 and order_type must be MARKET_TO_LIMIT).

symbol_sub_type
string

The sub type of the instrument symbol.

strict_limit
boolean

A flag that if set indicates this particular order must be filled at the exact limit price specified without price improvement.

good_till_time
string <date-time>

The time at which this order shall expire (required for time_in_force of GOOD_TILL_TIME, ignored otherwise).

best_limit
boolean

A flag that if set indicates that the price of a limit order shall be set to the price at the top of the book on the same side as this order.

immediately_executable_limit
boolean

A flag that if set indicates that the price of a limit order shall be set to the price at the top of the book on the opposing side as this order, thus able to immediately match.

trigger_method
string (v1beta1ConditionTriggerMethod)
Default: "CONDITION_TRIGGER_METHOD_UNDEFINED"
Enum: "CONDITION_TRIGGER_METHOD_UNDEFINED" "CONDITION_TRIGGER_METHOD_LAST_PRICE" "CONDITION_TRIGGER_METHOD_SETTLEMENT_PRICE"

ConditionTriggerMethod is the methodology used to trigger an order for insertion onto the book.

  • CONDITION_TRIGGER_METHOD_UNDEFINED: An unset value for the trigger method must be used when the order type is not meant to trigger (a limit order for instance) or uses the default last price method for orders that do trigger (a stop order for instance).
  • CONDITION_TRIGGER_METHOD_LAST_PRICE: Trigger the order using the last trade price on the book.
  • CONDITION_TRIGGER_METHOD_SETTLEMENT_PRICE: Trigger the order using the settlement price on the book.
self_match_prevention_instruction
string (v1beta1SelfMatchPreventionInstruction)
Default: "SELF_MATCH_PREVENTION_INSTRUCTION_UNDEFINED"
Enum: "SELF_MATCH_PREVENTION_INSTRUCTION_UNDEFINED" "SELF_MATCH_PREVENTION_INSTRUCTION_REJECT_AGGRESSOR" "SELF_MATCH_PREVENTION_INSTRUCTION_CANCEL_RESTING" "SELF_MATCH_PREVENTION_INSTRUCTION_REMOVE_BOTH"

SelfMatchPreventionInstruction is the methodology used to handle self match prevention upon insertion onto the book.

  • SELF_MATCH_PREVENTION_INSTRUCTION_UNDEFINED: An unset value for the self match prevention instruction uses the default behavior of the exchange, which is to reject the incoming order and allow resting orders to remain on the book.
  • SELF_MATCH_PREVENTION_INSTRUCTION_REJECT_AGGRESSOR: Reject the incoming aggressor order and allow resting orders to remain on the book.
  • SELF_MATCH_PREVENTION_INSTRUCTION_CANCEL_RESTING: Cancel any resting orders on the book that would self match and allow the aggressor to insert on the book.
  • SELF_MATCH_PREVENTION_INSTRUCTION_REMOVE_BOTH: Cancel any resting orders on the book that would self match and reject the aggressor insertion on the book.
order_capacity
string (v1beta1OrderCapacity)
Default: "ORDER_CAPACITY_UNDEFINED"
Enum: "ORDER_CAPACITY_UNDEFINED" "ORDER_CAPACITY_AGENCY" "ORDER_CAPACITY_PRINCIPAL" "ORDER_CAPACITY_PROPRIETARY" "ORDER_CAPACITY_INDIVIDUAL" "ORDER_CAPACITY_RISKLESS_PRINCIPAL" "ORDER_CAPACITY_AGENT_FOR_OTHER_MEMBER"

OrderCapacity designates the capacity of the party placing an order.

  • ORDER_CAPACITY_UNDEFINED: An unset value for the order capacity.
  • ORDER_CAPACITY_AGENCY: Firm is acting to match a customer order with another participant in the market in an agency capacity.
  • ORDER_CAPACITY_PRINCIPAL: Firm is trading with its own inventory and capital in a principal capacity.
  • ORDER_CAPACITY_PROPRIETARY: Firm is trading with its own inventory and capital in a proprietary capacity.
  • ORDER_CAPACITY_INDIVIDUAL: An individual is trading with their own inventory and capital.
  • ORDER_CAPACITY_RISKLESS_PRINCIPAL: Firm is placing a principal order that is party to an offsetting transaction.
  • ORDER_CAPACITY_AGENT_FOR_OTHER_MEMBER: Firm is acting to match a customer order with another participant in the market on behalf of another member.
ignore_price_validity_checks
boolean

A flag that if set indicates that this order is exempt from instrument level price, order, and total notional limits. Only allowed in case of market sell orders to support liquidation.

manual_order_indicator
string (v1beta1ManualOrderIndicator)
Default: "MANUAL_ORDER_INDICATOR_UNDEFINED"
Enum: "MANUAL_ORDER_INDICATOR_UNDEFINED" "MANUAL_ORDER_INDICATOR_MANUAL" "MANUAL_ORDER_INDICATOR_AUTOMATED"

ManualOrderIndicator designates the manual or automated nature of an order.

  • MANUAL_ORDER_INDICATOR_UNDEFINED: An unset value for the manual order indicator.
  • MANUAL_ORDER_INDICATOR_MANUAL: The order was initially received via manual entry.
  • MANUAL_ORDER_INDICATOR_AUTOMATED: The order was initially received electronically.
commission_override_basis_points
string

If present and an eligible singular commission with allow_order_entry_override is present for the order, assigns basis points to this value.

commission_override_flat_fee
string

If present and an eligible singular commission with allow_order_entry_override is present for the order, assigns flat fee to this value.

clord_link_id
string (Client assigned group ID for the order)
visible_qty
string <int64>

The visible quantity of the order. A non-zero value in this field indicates that the order is an iceberg order.

Responses

Request samples

Content type
application/json
{
  • "request": {
    }
}

Response samples

Content type
application/json
{
  • "preview_order": {
    }
}

PositionAPI

CreateAccountBalanceSubscription creates a subscription for currency balances in an account.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to start a balance subscription to get snapshots and updates for this session.

accounts
Array of strings

A set of fully qualified resource names of the accounts to filter upon in the subscription (ie: "firms/[firmid]/accounts/[accountid]") (optional).

Responses

Request samples

Content type
application/json
{
  • "accounts": [
    ]
}

Response samples

Content type
application/x-ndjson
{
  • "result": {
    },
  • "error": {
    }
}

CreatePositionSubscription creates a subscription for positions.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to start a position subscription to get snapshots and updates for this session.

accounts
Array of strings

A set of fully qualified resource names of the accounts to filter upon in the subscription (ie: "firms/[firmid]/accounts/[accountid]") (optional).

Responses

Request samples

Content type
application/json
{
  • "accounts": [
    ]
}

Response samples

Content type
application/x-ndjson
{
  • "result": {
    },
  • "error": {
    }
}

GetAccountBalance gets the balance for currency in an account.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to get the balance of the given account in the given currency.

name
string

Fully qualified resource name of the account to get the balance for (ie: "firms/[firmid]/accounts/[accountid]") (required).

currency
string

ISO currency code of the fiat currency for which to get the balance (ie: "USD") (required).

symbol_for_buying_power
string (Optional field used to return the calculated buying power on an account specifically for trading on that symbol)

Responses

Request samples

Content type
application/json
{
  • "name": "string",
  • "currency": "string",
  • "symbol_for_buying_power": "string"
}

Response samples

Content type
application/json
{
  • "balance": "string",
  • "capital_requirement": "string",
  • "excess_capital": "string",
  • "buying_power": "string",
  • "securities": {
    },
  • "total_security_notional_value": "string",
  • "total_security_available_value": "string",
  • "open_orders": "string",
  • "alternate_capital_requirement_currency": "string",
  • "alternate_capital_requirement": "string",
  • "unsettled_funds": "string",
  • "margin_requirement": "string",
  • "update_time": "2019-08-24T14:15:22Z"
}

ListAccountBalances lists the currency balances in an account.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to list the balances of a given account for all currencies.

name
string

Fully qualified resource name of the account to get the balances for (ie: "firms/[firmid]/accounts/[accountid]") (required).

symbol_for_buying_power
string (Optional field used to return the calculated buying power on an account specifically for trading on that symbol)

Responses

Request samples

Content type
application/json
{
  • "name": "string",
  • "symbol_for_buying_power": "string"
}

Response samples

Content type
application/json
{
  • "balances": {
    }
}

ListAccountPositions lists the positions within an account.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to list the positions of a given account.

name
string

Fully qualified resource name of the account to get the positions for (ie: "firms/[firmid]/accounts/[accountid]") (required).

symbol
string

Symbol to filter against within the account (optional).

Responses

Request samples

Content type
application/json
{
  • "name": "string",
  • "symbol": "string"
}

Response samples

Content type
application/json
{
  • "positions": [
    ],
  • "available_position": [
    ]
}

QuoteAPI

SearchQuotes lists all quotes matching the request.

Authorizations:
BearerAuth
Request Body schema: application/json
required
page_size
integer <int32>

The maximum number of objects to return in a response. This field is optional.

page_token
string

A pagination token returned from a previous call that indicates where this listing should continue from. This field is optional.

account
string
symbol
string
quote_request_id
string
quote_id
string
client_id
string
side
string (v1beta1Side)
Default: "SIDE_UNDEFINED"
Enum: "SIDE_UNDEFINED" "SIDE_BUY" "SIDE_SELL"

Side indicates the side of an Order.

statuses
Array of strings (v1beta1QuoteStatus)
Items Enum: "QUOTE_STATUS_UNDEFINED" "QUOTE_STATUS_PENDING" "QUOTE_STATUS_ACCEPTED" "QUOTE_STATUS_DELETED" "QUOTE_STATUS_EXPIRED" "QUOTE_STATUS_PASSED" "QUOTE_STATUS_DONE_AWAY" "QUOTE_STATUS_PENDING_RISK" "QUOTE_STATUS_REJECTED"
start_time
string <date-time> (Start time for the objects to be fetched)
end_time
string <date-time> (End time for the objects to be fetched)

Responses

Request samples

Content type
application/json
{
  • "page_size": 0,
  • "page_token": "string",
  • "account": "string",
  • "symbol": "string",
  • "quote_request_id": "string",
  • "quote_id": "string",
  • "client_id": "string",
  • "side": "SIDE_UNDEFINED",
  • "statuses": [
    ],
  • "start_time": "2019-08-24T14:15:22Z",
  • "end_time": "2019-08-24T14:15:22Z"
}

Response samples

Content type
application/json
{
  • "quotes": [
    ],
  • "next_page_token": "string",
  • "eof": true
}

SearchRequestForQuotes lists all request for quotes matching the request.

Authorizations:
BearerAuth
Request Body schema: application/json
required
page_size
integer <int32>

The maximum number of objects to return in a response. This field is optional.

page_token
string

A pagination token returned from a previous call that indicates where this listing should continue from. This field is optional.

account
string
symbol
string
quote_request_id
string
client_id
string
side
string (v1beta1Side)
Default: "SIDE_UNDEFINED"
Enum: "SIDE_UNDEFINED" "SIDE_BUY" "SIDE_SELL"

Side indicates the side of an Order.

statuses
Array of strings (v1beta1QuoteStatus)
Items Enum: "QUOTE_STATUS_UNDEFINED" "QUOTE_STATUS_PENDING" "QUOTE_STATUS_ACCEPTED" "QUOTE_STATUS_DELETED" "QUOTE_STATUS_EXPIRED" "QUOTE_STATUS_PASSED" "QUOTE_STATUS_DONE_AWAY" "QUOTE_STATUS_PENDING_RISK" "QUOTE_STATUS_REJECTED"
start_time
string <date-time> (Start time for the objects to be fetched)
end_time
string <date-time> (End time for the objects to be fetched)

Responses

Request samples

Content type
application/json
{
  • "page_size": 0,
  • "page_token": "string",
  • "account": "string",
  • "symbol": "string",
  • "quote_request_id": "string",
  • "client_id": "string",
  • "side": "SIDE_UNDEFINED",
  • "statuses": [
    ],
  • "start_time": "2019-08-24T14:15:22Z",
  • "end_time": "2019-08-24T14:15:22Z"
}

Response samples

Content type
application/json
{
  • "request_for_quotes": [
    ],
  • "next_page_token": "string",
  • "eof": true
}

QuoteEntryAPI

CreateQuote inserts a quote into the exchange.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to insert a quote into the exchange.

parent
string

Exchange assigned ID for the parent quote request that this quote references (required).

object (connamaraep3v1beta1Quote)

Quote is a quote sent to and from the RFQ Exchange.

Responses

Request samples

Content type
application/json
{
  • "parent": "string",
  • "quote": {
    }
}

Response samples

Content type
application/json
{ }

CreateQuoteSubscription creates a subscription for working quotes and requests.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to start a quote subscription to get snapshots and updates for this session.

object (v1beta1CreateQuoteSubscriptionRequest)

Request to start a quote subscription to get snapshots and updates for this session.

Responses

Request samples

Content type
application/json
{ }

Response samples

Content type
application/x-ndjson
{
  • "result": {
    },
  • "error": {
    }
}

CreateRequestForQuote inserts a request for quote into the exchange.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to insert a request for quote into the exchange.

object (connamaraep3v1beta1RequestForQuote)

RequestForQuote is a quote request into the RFQ Exchange.

id
string (Exchange assigned ID for the quote request)
name
string (Exchange assigned resource name for the quote request)
client_id
string (Client assigned ID for this quote request)
side
string (v1beta1Side)
Default: "SIDE_UNDEFINED"
Enum: "SIDE_UNDEFINED" "SIDE_BUY" "SIDE_SELL"

Side indicates the side of an Order.

order_qty
string <int64>
symbol
string
expiration_time
string <date-time> (Timestamp at which this quote will expire)
account
string (Account is the trading account for this quote request)
user
string (The market participant that created this quote request)
firms
Array of strings (Whitelist of targeted firms that this quote request will target)
insert_time
string <date-time> (The time this request was inserted into the exchange)
status
string (v1beta1QuoteStatus)
Default: "QUOTE_STATUS_UNDEFINED"
Enum: "QUOTE_STATUS_UNDEFINED" "QUOTE_STATUS_PENDING" "QUOTE_STATUS_ACCEPTED" "QUOTE_STATUS_DELETED" "QUOTE_STATUS_EXPIRED" "QUOTE_STATUS_PASSED" "QUOTE_STATUS_DONE_AWAY" "QUOTE_STATUS_PENDING_RISK" "QUOTE_STATUS_REJECTED"

QuoteStatus indicates the status of a quote.

  • QUOTE_STATUS_UNDEFINED: Default undefined state.
  • QUOTE_STATUS_PENDING: Quote is pending and awaiting a decision by the RFQ sender to choose which quote they want to take.
  • QUOTE_STATUS_ACCEPTED: Quote is accepted. A quote is accepted when the RFQ sender chooses this quote to fulfill its request.
  • QUOTE_STATUS_DELETED: Quote is deleted. When the party that has sent the original quote cancels it, the quote becomes deleted.
  • QUOTE_STATUS_EXPIRED: Quote is expired. A quote that has passed its expiration time becomes expired.
  • QUOTE_STATUS_PASSED: Quote is passed. A quote is passed when the user chose not to accept this quote.
  • QUOTE_STATUS_DONE_AWAY: Quote is done away. A quote is done away when another quote has been accepted instead of this one.
  • QUOTE_STATUS_PENDING_RISK: quote is pending risk approval
  • QUOTE_STATUS_REJECTED: quote is rejected by the exchange
firm
string (The firm that created this quote request)
submitting_user
string (The agent participant that created this quote request on behalf of the designated user)
symbol_sub_type
string (The sub type of the instrument symbol)
cash_order_qty
string <int64> (Fixed point decimal representation of the total cash order qty)

Responses

Request samples

Content type
application/json
{
  • "request_for_quote": {
    }
}

Response samples

Content type
application/json
{ }

DeleteQuote deletes a quote from the exchange.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to delete a quote from the exchange.

name
string

Exchange assigned ID for the quote to be deleted.

Responses

Request samples

Content type
application/json
{
  • "name": "string"
}

Response samples

Content type
application/json
{ }

ListDealers returns the whitelist of firms that are able to receive a request for quote that I send.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to get the whitelist of firms that are able to receive a request for quote that I send.

object (v1beta1ListDealersRequest)

Request to get the whitelist of firms that are able to receive a request for quote that I send.

Responses

Request samples

Content type
application/json
{ }

Response samples

Content type
application/json
{
  • "firms": [
    ],
  • "display_names": [
    ]
}

ListRequesters returns the whitelist of firms that are able to send a request for quote to my firm.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to get the whitelist of firms that are able to send a request for quote to my firm.

object (v1beta1ListRequestersRequest)

Request to get the whitelist of firms that are able to send a request for quote to my firm.

Responses

Request samples

Content type
application/json
{ }

Response samples

Content type
application/json
{
  • "firms": [
    ],
  • "display_names": [
    ]
}

PassQuote passes on a quote from the exchange.

Authorizations:
BearerAuth
Request Body schema: application/json
required

Request to pass on a quote from the exchange.

name
string

Exchange assigned ID for the quote to pass on.

Responses

Request samples

Content type
application/json
{
  • "name": "string"
}

Response samples

Content type
application/json
{ }